window.makecommerce = [];

var AppMakeCommercePayments = {
    init: () => {
        $('#cart_navigation > ').on('click', function(evt) {
            $('#veebipoed-overlay').show();
        });

        $('[name="payment-option"]').on('click', function (e) {
            if (e.target.getAttribute('data-module-name').includes('makecommercepayments')) {
                var currentURL = window.location.href;

                if (!currentURL.includes('submitReorder=')) {
                    if (currentURL.includes('?')) {
                        history.pushState(null, "", currentURL + "&submitReorder=true");
                    } else {
                        history.pushState(null, "", currentURL + "?submitReorder=true");
                    }
                }
            }
        })

        $('.payment-method').on('click', function(evt) {
            evt.preventDefault();
            $('#veebipoed-overlay').show();
            $.ajax(mk_ajax_url, {
                'data': 'action=create_transaction&method='+$(this).data('method'),
                'dataType': 'json'
            }).success(function(data) {
                if (data.type == 'banklinks' || data.type == 'other' || data.type == 'payLater') {
                    window.location.href = data.url;
                } else {
                    $('#center_column').append(data.html);
                    var interval_id = setInterval(function() {
                        if (typeof window.Maksekeskus == 'object' &&
                            typeof window.Maksekeskus.Checkout == 'object'
                        ) {
                            $('#makecommerce-form').replaceWith(function(){
                                return $('<form method="POST" id="makecommerce-form"></form>').append($(this).contents());
                            });
                            window.Maksekeskus.Checkout.initialize();
                            window.Maksekeskus.Checkout.open();
                            $('.payment-method').off('click').on('click', function(evt) {
                                evt.preventDefault();
                                evt.stopPropagation();
                                window.Maksekeskus.Checkout.open();
                            });
                            clearInterval(interval_id);
                            $('#veebipoed-overlay').hide();
                        }
                    }, 100);
                }
            });
        });

        //Hide widget settings if payment display method isn't widget
        if($('#methods_display').val() != 2)
            $('.widget_setting').hide();
        $('#methods_display').change(function() {
            if($('#methods_display').val() == 2){
                $('.widget_setting').show();
            }else{
                $('.widget_setting').hide();
            }
        });

        if($('#server').val() == 0){
            $('.test_settings').show();
            $('.live_settings').hide();
        }else{
            $('.test_settings').hide();
            $('.live_settings').show();
        }

        $('#server').change(function() {
            if($('#server').val() == 0){
                $('.test_settings').show();
                $('.live_settings').hide();
            }else{
                $('.test_settings').hide();
                $('.live_settings').show();
            }
        });

        if($('.adminorders #formAddPaymentPanel').lenght){
            $('.adminorders #formAddPaymentPanel').after($('#makecommerce_refund'));
        }else{
            $('.adminorders #formAddPayment').parent().after($('#makecommerce_refund'));
        }
        // Move makecommerce label block
        if($('.adminorders #formAddPaymentPanel').lenght){
            $('.adminorders #formAddPaymentPanel').before($('#makecommerce_label'));
        }else{
            $('.adminorders #formAddPayment').parent().before($('#makecommerce_label'));
        }

        if (typeof(mk_show_country_code) != "undefined" && mk_show_country_code !== null && mk_show_country_code !== "") {
            var country = $('.flag_mk_select .selected a').data('country');
            $('.mk_method:not(.mk_country-all)').hide();
            $('.mk_country-'+country).show();
            $('.flag_mk_select a').click(function(e) {
                e.preventDefault();
                $('.flag_mk_select li').removeClass('selected');
                $(this).closest('li').addClass('selected');
                var country = $('.flag_mk_select .selected a').data('country');
                $('.mk_method:not(.mk_country-all)').hide();
                $('.mk_country-'+country).show();
            });
        }

        // Temporary workaround
        $(function() {
            if ($('.payment-option').length == 1 && $('[data-module-name="makecommercepayments"]').length) {
                $('[data-module-name="makecommercepayments"]').prop('checked', false);
                $('[data-module-name="makecommercepayments"]').trigger('click');
            }
        });

        // Terms & conditions checkbox
        $('input[id="conditions_to_approve[terms-and-conditions]"]').on('change', function() {
            let targetButton = null;
            let isMakeCommerceModule = null;
            if (typeof(onePageCheckout) !== "undefined") {
                isMakeCommerceModule = $("[data-payment-module='makecommercepayments'] input")[0].checked;
                targetButton = $('#confirm_order');
            } else {
                isMakeCommerceModule = $("[data-module-name='makecommercepayments']")[0].checked;
                targetButton = $('#payment-confirmation button');
            }
            if (this.checked && (window.makecommerce.payment_url || !isMakeCommerceModule)
            ) {
                targetButton.removeAttr('disabled').removeClass('disabled');
            } else {
                targetButton.attr('disabled', 'disabled');
                setOrderButton();
            }

            return false;
        });

        // Payment method click (list)
        $('#mk_list .payment_module a').on('click', function(event) {
            event.preventDefault();
            $('#mk_list .payment_module a').removeClass('mk_method_selected_list');
            $(this).addClass('mk_method_selected_list');
            window.makecommerce.payment_url = $(this).attr('href');
            setOrderButton();
            return false;
        });

        // Payment method click (widget)
        $('#mk_widget .mk_method a').on('click', function(event) {
            event.preventDefault();
            $('.mk_method').removeClass('mk_method_selected');
            $(this).parent().addClass('mk_method_selected');
            window.makecommerce.payment_url = $(this).attr('href');
            setOrderButton();
            return false;
        });
    }
};

if (typeof OPC !== typeof undefined) {
    prestashop.on('opc-payment-getPaymentList-complete', () => {
        console.log('opc-payment-getPaymentList-complete');
        AppMakeCommercePayments.init();
    });
} else {
    $(function() {
        AppMakeCommercePayments.init();
    });
}

/*
completed function for CC
 */
function makecommerce_cc_complete(data){
    var submitform = jQuery('<form action="/module/makecommerce/val" method="POST" style="display: none;"></form>');

    for (var key in data) {
        submitform.append(jQuery('<input type="hidden" name="' + key + '" />').val(data[key]));
    }

    jQuery('body').append(submitform);

    submitform.submit();
}


function setOrderButton() {
    // Adjust order button
    let targetButton = null;

    if (typeof(onePageCheckout) !== "undefined") {
        targetButton = $('#confirm_order');
    } else {
        targetButton = $('#payment-confirmation button');
    }

    targetButton.addClass('disabled').attr('disabled', 'disabled');

    if (window.makecommerce.payment_url) {
        let enableOrder = true;

        if (typeof(onePageCheckout) !== "undefined") {
            $('#tc-payment-confirmation input[type="checkbox"]').each((_, checkbox) => {
                if (!checkbox.checked) {
                    enableOrder = false;
                }
            });
        } else {
            $('#checkout-payment-step input[type="checkbox"]').each((_, checkbox) => {
                if (!checkbox.checked) {
                    enableOrder = false;
                }
            });
        }

        if (enableOrder && $('.payment_method_list').children().find('.mk_method_selected').length) {
            enableOrder = true;
        }

        if (enableOrder) {
            targetButton.removeClass('disabled').removeAttr('disabled');
        }

        targetButton.on('click', function(event) {
            if (!$(this).hasClass('disabled')) {
                window.location.href = window.makecommerce.payment_url;
            }
            event.preventDefault();
            return false;
        });
    }
}

function mkBlockSubmit() {
    mkchecked = $('input[id="conditions_to_approve[terms-and-conditions]"]:checked').length;
    if (mkchecked) {
        mkid = $("input[data-module-name='makecommercepayments']").attr('id');
        if ($('#' + mkid + '-additional-information').css("display") != null) {
            $('#payment-confirmation').find('.btn.btn-primary.center-block').attr('disabled','disabled');
            mkBlockSubmit();
        }
    }
}
